org.keycloak.common.util

## Class Base64

- java.lang.Object
- - org.keycloak.common.util.Base64

-     public class Base64
      extends Object

  Encodes and decodes to and from Base64 notation.

  Homepage: http://iharder.net/base64.

  Example:

  `String encoded = Base64.encode( myByteArray );`
  `byte[] myByteArray = Base64.decode( encoded );`

  The `options` parameter, which appears in a few places, is used to pass several pieces of information to the encoder. In the "higher level" methods such as encodeBytes( bytes, options ) the options parameter can be used to indicate such things as first gzipping the bytes before encoding them, not inserting linefeeds, and encoding using the URL-safe and Ordered dialects.

  Note, according to RFC3548, Section 2.1, implementations should not add line feeds unless explicitly told to do so. I've got Base64 set to this behavior now, although earlier versions broke lines by default.

  The constants defined in Base64 can be OR-ed together to combine options, so you might make a call like this:

  `String encoded = Base64.encodeBytes( mybytes, Base64.GZIP | Base64.DO_BREAK_LINES );`

  to compress the data before encoding it and then making the output have newline characters.

  Also...

  `String encoded = Base64.encodeBytes( crazyString.getBytes() );`

  Change Log:

  - v2.3.7 - Fixed subtle bug when base 64 input stream contained the value 01111111, which is an invalid base 64 character but should not throw an ArrayIndexOutOfBoundsException either. Led to discovery of mishandling (or potential for better handling) of other bad input characters. You should now get an IOException if you try decoding something that has bad characters in it.
  - v2.3.6 - Fixed bug when breaking lines and the final byte of the encoded string ended in the last column; the buffer was not properly shrunk and contained an extra (null) byte that made it into the string.
  - v2.3.5 - Fixed bug in `encodeFromFile(java.lang.String)` where estimated buffer size was wrong for files of size 31, 34, and 37 bytes.
  - v2.3.4 - Fixed bug when working with gzipped streams whereby flushing the Base64.OutputStream closed the Base64 encoding (by padding with equals signs) too soon. Also added an option to suppress the automatic decoding of gzipped streams. Also added experimental support for specifying a class loader when using the `decodeToObject(java.lang.String, int, java.lang.ClassLoader)` method.
  - v2.3.3 - Changed default char encoding to US-ASCII which reduces the internal Java footprint with its CharEncoders and so forth. Fixed some javadocs that were inconsistent. Removed imports and specified things like java.io.IOException explicitly inline.
  - v2.3.2 - Reduced memory footprint! Finally refined the "guessing" of how big the final encoded data will be so that the code doesn't have to create two output arrays: an oversized initial one and then a final, exact-sized one. Big win when using the `encodeBytesToBytes(byte[])` family of methods (and not using the gzip options which uses a different mechanism with streams and stuff).
  - v2.3.1 - Added `encodeBytesToBytes(byte[], int, int, int)` and some similar helper methods to be more efficient with memory by not returning a String but just a byte array.
  - v2.3 - This is not a drop-in replacement! This is two years of comments and bug fixes queued up and finally executed. Thanks to everyone who sent me stuff, and I'm sorry I wasn't able to distribute your fixes to everyone else. Much bad coding was cleaned up including throwing exceptions where necessary instead of returning null values or something similar. Here are some changes that may affect you:
    - Does not break lines, by default. This is to keep in compliance with RFC3548.
    - Throws exceptions instead of returning null values. Because some operations (especially those that may permit the GZIP option) use IO streams, there is a possiblity of an java.io.IOException being thrown. After some discussion and thought, I've changed the behavior of the methods to throw java.io.IOExceptions rather than return null if ever there's an error. I think this is more appropriate, though it will require some changes to your code. Sorry, it should have been done this way to begin with.
    - Removed all references to System.out, System.err, and the like. Shame on me. All I can say is sorry they were ever there.
    - Throws NullPointerExceptions and IllegalArgumentExceptions as needed such as when passed arrays are null or offsets are invalid.
    - Cleaned up as much javadoc as I could to avoid any javadoc warnings. This was especially annoying before for people who were thorough in their own projects and then had gobs of javadoc warnings on this file.
  - v2.2.1 - Fixed bug using URL_SAFE and ORDERED encodings. Fixed bug when using very small files (~< 40 bytes).
  - v2.2 - Added some helper methods for encoding/decoding directly from one file to the next. Also added a main() method to support command line encoding/decoding from one file to the next. Also added these Base64 dialects:
    1. The default is RFC3548 format.
    2. Calling Base64.setFormat(Base64.BASE64_FORMAT.URLSAFE_FORMAT) generates URL and file name friendly format as described in Section 4 of RFC3548. http://www.faqs.org/rfcs/rfc3548.html
    3. Calling Base64.setFormat(Base64.BASE64_FORMAT.ORDERED_FORMAT) generates URL and file name friendly format that preserves lexical ordering as described in http://www.faqs.org/qa/rfcc-1940.html
    Special thanks to Jim Kellerman at http://www.powerset.com/ for contributing the new Base64 dialects.
  - v2.1 - Cleaned up javadoc comments and unused variables and methods. Added some convenience methods for reading and writing to and from files.
  - v2.0.2 - Now specifies UTF-8 encoding in places where the code fails on systems with other encodings (like EBCDIC).
  - v2.0.1 - Fixed an error when decoding a single byte, that is, when the encoded data was a single byte.
  - v2.0 - I got rid of methods that used booleans to set options. Now everything is more consolidated and cleaner. The code now detects when data that's being decoded is gzip-compressed and will decompress it automatically. Generally things are cleaner. You'll probably have to change some method calls that you were making to support the new options format (`int`s that you "OR" together).
  - v1.5.1 - Fixed bug when decompressing and decoding to a byte[] using `decode( String s, boolean gzipCompressed )`. Added the ability to "suspend" encoding in the Output Stream so you can turn on and off the encoding if you need to embed base64 data in an otherwise "normal" stream (like an XML file).
  - v1.5 - Output stream pases on flush() command but doesn't do anything itself. This helps when using GZIP streams. Added the ability to GZip-compress objects before encoding them.
  - v1.4 - Added helper methods to read/write files.
  - v1.3.6 - Fixed OutputStream.flush() so that 'position' is reset.
  - v1.3.5 - Added flag to turn on and off line breaks. Fixed bug in input stream where last buffer being read, if not completely full, was not returned.
  - v1.3.4 - Fixed when "improperly padded stream" error was thrown at the wrong time.
  - v1.3.3 - Fixed I/O streams which were totally messed up.

  I am placing this code in the Public Domain. Do with it as you will. This software comes with no guarantees or warranties but with plenty of well-wishing instead! Please visit http://iharder.net/base64 periodically to check for updates or to contribute improvements.

  Version:
    2.3.7
  Author:
    Robert Harder, rob@iharder.net

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `Base64.InputStream` A `Base64.InputStream` will read data from another `java.io.InputStream`, given in the constructor, and encode/decode to/from Base64 notation on the fly.
    `static class` | `Base64.OutputStream` A `Base64.OutputStream` will write data to another `java.io.OutputStream`, given in the constructor, and encode/decode to/from Base64 notation on the fly.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DECODE` Specify decoding in first bit.
    `static int` | `DO_BREAK_LINES` Do break lines when encoding.
    `static int` | `DONT_GUNZIP` Specify that gzipped data should not be automatically gunzipped.
    `static int` | `ENCODE` Specify encoding in first bit.
    `static int` | `GZIP` Specify that data should be gzip-compressed in second bit.
    `static int` | `NO_OPTIONS` No options specified.
    `static int` | `ORDERED` Encode using the special "ordered" dialect of Base64 described here: http://www.faqs.org/qa/rfcc-1940.html.
    `static int` | `URL_SAFE` Encode using Base64-like encoding that is URL- and Filename-safe as described in Section 4 of RFC3548: http://www.faqs.org/rfcs/rfc3548.html.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static byte[]` | `decode(byte[] source)` Low-level access to decoding ASCII characters in the form of a byte array.
    `static byte[]` | `decode(byte[] source, int off, int len, int options)` Low-level access to decoding ASCII characters in the form of a byte array.
    `static byte[]` | `decode(String s)` Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.
    `static byte[]` | `decode(String s, int options)` Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.
    `static void` | `decodeFileToFile(String infile, String outfile)` Reads `infile` and decodes it to `outfile`.
    `static byte[]` | `decodeFromFile(String filename)` Convenience method for reading a base64-encoded file and decoding it.
    `static void` | `decodeToFile(String dataToDecode, String filename)` Convenience method for decoding data to a file.
    `static Object` | `decodeToObject(String encodedObject)` Attempts to decode Base64 data and deserialize a Java Object within.
    `static Object` | `decodeToObject(String encodedObject, int options, ClassLoader loader)` Attempts to decode Base64 data and deserialize a Java Object within.
    `static void` | `encode(ByteBuffer raw, ByteBuffer encoded)` Performs Base64 encoding on the `raw` ByteBuffer, writing it to the `encoded` ByteBuffer.
    `static void` | `encode(ByteBuffer raw, CharBuffer encoded)` Performs Base64 encoding on the `raw` ByteBuffer, writing it to the `encoded` CharBuffer.
    `static String` | `encodeBytes(byte[] source)` Encodes a byte array into Base64 notation.
    `static String` | `encodeBytes(byte[] source, int options)` Encodes a byte array into Base64 notation.
    `static String` | `encodeBytes(byte[] source, int off, int len)` Encodes a byte array into Base64 notation.
    `static String` | `encodeBytes(byte[] source, int off, int len, int options)` Encodes a byte array into Base64 notation.
    `static byte[]` | `encodeBytesToBytes(byte[] source)` Similar to `encodeBytes(byte[])` but returns a byte array instead of instantiating a String.
    `static byte[]` | `encodeBytesToBytes(byte[] source, int off, int len, int options)` Similar to `encodeBytes(byte[], int, int, int)` but returns a byte array instead of instantiating a String.
    `static void` | `encodeFileToFile(String infile, String outfile)` Reads `infile` and encodes it to `outfile`.
    `static String` | `encodeFromFile(String filename)` Convenience method for reading a binary file and base64-encoding it.
    `static String` | `encodeObject(Serializable serializableObject)` Serializes an object and returns the Base64-encoded version of that serialized object.
    `static String` | `encodeObject(Serializable serializableObject, int options)` Serializes an object and returns the Base64-encoded version of that serialized object.
    `static void` | `encodeToFile(byte[] dataToEncode, String filename)` Convenience method for encoding data to a file.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### NO_OPTIONS

          public static final int NO_OPTIONS

      No options specified. Value is zero.
      See Also:
        Constant Field Values

    - #### ENCODE

          public static final int ENCODE

      Specify encoding in first bit. Value is one.
      See Also:
        Constant Field Values

    - #### DECODE

          public static final int DECODE

      Specify decoding in first bit. Value is zero.
      See Also:
        Constant Field Values

    - #### GZIP

          public static final int GZIP

      Specify that data should be gzip-compressed in second bit. Value is two.
      See Also:
        Constant Field Values

    - #### DONT_GUNZIP

          public static final int DONT_GUNZIP

      Specify that gzipped data should not be automatically gunzipped.
      See Also:
        Constant Field Values

    - #### DO_BREAK_LINES

          public static final int DO_BREAK_LINES

      Do break lines when encoding. Value is 8.
      See Also:
        Constant Field Values

    - #### URL_SAFE

          public static final int URL_SAFE

      Encode using Base64-like encoding that is URL- and Filename-safe as described in Section 4 of RFC3548: http://www.faqs.org/rfcs/rfc3548.html. It is important to note that data encoded this way is not officially valid Base64, or at the very least should not be called Base64 without also specifying that is was encoded using the URL- and Filename-safe dialect.
      See Also:
        Constant Field Values

    - #### ORDERED

          public static final int ORDERED

      Encode using the special "ordered" dialect of Base64 described here: http://www.faqs.org/qa/rfcc-1940.html.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### encode

          public static void encode(ByteBuffer raw,
                                    ByteBuffer encoded)

      Performs Base64 encoding on the `raw` ByteBuffer, writing it to the `encoded` ByteBuffer. This is an experimental feature. Currently it does not pass along any options (such as `DO_BREAK_LINES` or `GZIP`.
      Parameters:
        `raw` - input buffer
        `encoded` - output buffer
      Since:
        2.3

    - #### encode

          public static void encode(ByteBuffer raw,
                                    CharBuffer encoded)

      Performs Base64 encoding on the `raw` ByteBuffer, writing it to the `encoded` CharBuffer. This is an experimental feature. Currently it does not pass along any options (such as `DO_BREAK_LINES` or `GZIP`.
      Parameters:
        `raw` - input buffer
        `encoded` - output buffer
      Since:
        2.3

    - #### encodeObject

          public static String encodeObject(Serializable serializableObject)
                                     throws IOException

      Serializes an object and returns the Base64-encoded version of that serialized object.

      As of v 2.3, if the object cannot be serialized or there is another error, the method will throw an java.io.IOException. This is new to v2.3! In earlier versions, it just returned a null value, but in retrospect that's a pretty poor way to handle it.

      The object is not GZip-compressed before being encoded.
      Parameters:
        `serializableObject` - The object to encode
      Returns:
        The Base64-encoded object
      Throws:
        `IOException` - if there is an error
        `NullPointerException` - if serializedObject is null
      Since:
        1.4

    - #### encodeObject

          public static String encodeObject(Serializable serializableObject,
                                            int options)
                                     throws IOException

      Serializes an object and returns the Base64-encoded version of that serialized object.

      As of v 2.3, if the object cannot be serialized or there is another error, the method will throw an java.io.IOException. This is new to v2.3! In earlier versions, it just returned a null value, but in retrospect that's a pretty poor way to handle it.

      The object is not GZip-compressed before being encoded.

      Example options:

             GZIP: gzip-compresses object before encoding it.
             DO_BREAK_LINES: break lines at 76 characters

      Example: `encodeObject( myObj, Base64.GZIP )` or

      Example: `encodeObject( myObj, Base64.GZIP | Base64.DO_BREAK_LINES )`

      Parameters:
        `serializableObject` - The object to encode
        `options` - Specified options
      Returns:
        The Base64-encoded object
      Throws:
        `IOException` - if there is an error
      Since:
        2.0
      See Also:
        `GZIP`, `DO_BREAK_LINES`

    - #### encodeBytes

          public static String encodeBytes(byte[] source)

      Encodes a byte array into Base64 notation. Does not GZip-compress data.
      Parameters:
        `source` - The data to convert
      Returns:
        The data in Base64-encoded form
      Throws:
        `NullPointerException` - if source array is null
      Since:
        1.4

    - #### encodeBytes

          public static String encodeBytes(byte[] source,
                                           int options)
                                    throws IOException

      Encodes a byte array into Base64 notation.

      Example options:

             GZIP: gzip-compresses object before encoding it.
             DO_BREAK_LINES: break lines at 76 characters
               Note: Technically, this makes your encoding non-compliant.

      Example: `encodeBytes( myData, Base64.GZIP )` or

      Example: `encodeBytes( myData, Base64.GZIP | Base64.DO_BREAK_LINES )`

      As of v 2.3, if there is an error with the GZIP stream, the method will throw an java.io.IOException. This is new to v2.3! In earlier versions, it just returned a null value, but in retrospect that's a pretty poor way to handle it.

      Parameters:
        `source` - The data to convert
        `options` - Specified options
      Returns:
        The Base64-encoded data as a String
      Throws:
        `IOException` - if there is an error
        `NullPointerException` - if source array is null
      Since:
        2.0
      See Also:
        `GZIP`, `DO_BREAK_LINES`

    - #### encodeBytes

          public static String encodeBytes(byte[] source,
                                           int off,
                                           int len)

      Encodes a byte array into Base64 notation. Does not GZip-compress data.

      As of v 2.3, if there is an error, the method will throw an java.io.IOException. This is new to v2.3! In earlier versions, it just returned a null value, but in retrospect that's a pretty poor way to handle it.

      Parameters:
        `source` - The data to convert
        `off` - Offset in array where conversion should begin
        `len` - Length of data to convert
      Returns:
        The Base64-encoded data as a String
      Throws:
        `NullPointerException` - if source array is null
        `IllegalArgumentException` - if source array, offset, or length are invalid
      Since:
        1.4

    - #### encodeBytes

          public static String encodeBytes(byte[] source,
                                           int off,
                                           int len,
                                           int options)
                                    throws IOException

      Encodes a byte array into Base64 notation.

      Example options:

             GZIP: gzip-compresses object before encoding it.
             DO_BREAK_LINES: break lines at 76 characters
               Note: Technically, this makes your encoding non-compliant.

      Example: `encodeBytes( myData, Base64.GZIP )` or

      Example: `encodeBytes( myData, Base64.GZIP | Base64.DO_BREAK_LINES )`

      As of v 2.3, if there is an error with the GZIP stream, the method will throw an java.io.IOException. This is new to v2.3! In earlier versions, it just returned a null value, but in retrospect that's a pretty poor way to handle it.

      Parameters:
        `source` - The data to convert
        `off` - Offset in array where conversion should begin
        `len` - Length of data to convert
        `options` - Specified options
      Returns:
        The Base64-encoded data as a String
      Throws:
        `IOException` - if there is an error
        `NullPointerException` - if source array is null
        `IllegalArgumentException` - if source array, offset, or length are invalid
      Since:
        2.0
      See Also:
        `GZIP`, `DO_BREAK_LINES`

    - #### encodeBytesToBytes

          public static byte[] encodeBytesToBytes(byte[] source)

      Similar to `encodeBytes(byte[])` but returns a byte array instead of instantiating a String. This is more efficient if you're working with I/O streams and have large data sets to encode.
      Parameters:
        `source` - The data to convert
      Returns:
        The Base64-encoded data as a byte[] (of ASCII characters)
      Throws:
        `NullPointerException` - if source array is null
      Since:
        2.3.1

    - #### encodeBytesToBytes

          public static byte[] encodeBytesToBytes(byte[] source,
                                                  int off,
                                                  int len,
                                                  int options)
                                           throws IOException

      Similar to `encodeBytes(byte[], int, int, int)` but returns a byte array instead of instantiating a String. This is more efficient if you're working with I/O streams and have large data sets to encode.
      Parameters:
        `source` - The data to convert
        `off` - Offset in array where conversion should begin
        `len` - Length of data to convert
        `options` - Specified options
      Returns:
        The Base64-encoded data as a String
      Throws:
        `IOException` - if there is an error
        `NullPointerException` - if source array is null
        `IllegalArgumentException` - if source array, offset, or length are invalid
      Since:
        2.3.1
      See Also:
        `GZIP`, `DO_BREAK_LINES`

    - #### decode

          public static byte[] decode(byte[] source)
                               throws IOException

      Low-level access to decoding ASCII characters in the form of a byte array. Ignores GUNZIP option, if it's set. This is not generally a recommended method, although it is used internally as part of the decoding process. Special case: if len = 0, an empty array is returned. Still, if you need more speed and reduced memory footprint (and aren't gzipping), consider this method.
      Parameters:
        `source` - The Base64 encoded data
      Returns:
        decoded data
      Throws:
        `IOException`
      Since:
        2.3.1

    - #### decode

          public static byte[] decode(byte[] source,
                                      int off,
                                      int len,
                                      int options)
                               throws IOException

      Low-level access to decoding ASCII characters in the form of a byte array. Ignores GUNZIP option, if it's set. This is not generally a recommended method, although it is used internally as part of the decoding process. Special case: if len = 0, an empty array is returned. Still, if you need more speed and reduced memory footprint (and aren't gzipping), consider this method.
      Parameters:
        `source` - The Base64 encoded data
        `off` - The offset of where to begin decoding
        `len` - The length of characters to decode
        `options` - Can specify options such as alphabet type to use
      Returns:
        decoded data
      Throws:
        `IOException` - If bogus characters exist in source data
      Since:
        1.3

    - #### decode

          public static byte[] decode(String s)
                               throws IOException

      Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.
      Parameters:
        `s` - the string to decode
      Returns:
        the decoded data
      Throws:
        `IOException` - If there is a problem
      Since:
        1.4

    - #### decode

          public static byte[] decode(String s,
                                      int options)
                               throws IOException

      Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.
      Parameters:
        `s` - the string to decode
        `options` - encode options such as URL_SAFE
      Returns:
        the decoded data
      Throws:
        `IOException` - if there is an error
        `NullPointerException` - if `s` is null
      Since:
        1.4

    - #### decodeToObject

          public static Object decodeToObject(String encodedObject)
                                       throws IOException,
                                              ClassNotFoundException

      Attempts to decode Base64 data and deserialize a Java Object within. Returns `null` if there was an error.
      Parameters:
        `encodedObject` - The Base64 data to decode
      Returns:
        The decoded and deserialized object
      Throws:
        `NullPointerException` - if encodedObject is null
        `IOException` - if there is a general error
        `ClassNotFoundException` - if the decoded object is of a class that cannot be found by the JVM
      Since:
        1.5

    - #### decodeToObject

          public static Object decodeToObject(String encodedObject,
                                              int options,
                                              ClassLoader loader)
                                       throws IOException,
                                              ClassNotFoundException

      Attempts to decode Base64 data and deserialize a Java Object within. Returns `null` if there was an error. If `loader` is not null, it will be the class loader used when deserializing.
      Parameters:
        `encodedObject` - The Base64 data to decode
        `options` - Various parameters related to decoding
        `loader` - Optional class loader to use in deserializing classes.
      Returns:
        The decoded and deserialized object
      Throws:
        `NullPointerException` - if encodedObject is null
        `IOException` - if there is a general error
        `ClassNotFoundException` - if the decoded object is of a class that cannot be found by the JVM
      Since:
        2.3.4

    - #### encodeToFile

          public static void encodeToFile(byte[] dataToEncode,
                                          String filename)
                                   throws IOException

      Convenience method for encoding data to a file.

      As of v 2.3, if there is a error, the method will throw an java.io.IOException. This is new to v2.3! In earlier versions, it just returned false, but in retrospect that's a pretty poor way to handle it.

      Parameters:
        `dataToEncode` - byte array of data to encode in base64 form
        `filename` - Filename for saving encoded data
      Throws:
        `IOException` - if there is an error
        `NullPointerException` - if dataToEncode is null
      Since:
        2.1

    - #### decodeToFile

          public static void decodeToFile(String dataToDecode,
                                          String filename)
                                   throws IOException

      Convenience method for decoding data to a file.

      As of v 2.3, if there is a error, the method will throw an java.io.IOException. This is new to v2.3! In earlier versions, it just returned false, but in retrospect that's a pretty poor way to handle it.

      Parameters:
        `dataToDecode` - Base64-encoded data as a string
        `filename` - Filename for saving decoded data
      Throws:
        `IOException` - if there is an error
      Since:
        2.1

    - #### decodeFromFile

          public static byte[] decodeFromFile(String filename)
                                       throws IOException

      Convenience method for reading a base64-encoded file and decoding it.

      As of v 2.3, if there is a error, the method will throw an java.io.IOException. This is new to v2.3! In earlier versions, it just returned false, but in retrospect that's a pretty poor way to handle it.

      Parameters:
        `filename` - Filename for reading encoded data
      Returns:
        decoded byte array
      Throws:
        `IOException` - if there is an error
      Since:
        2.1

    - #### encodeFromFile

          public static String encodeFromFile(String filename)
                                       throws IOException

      Convenience method for reading a binary file and base64-encoding it.

      As of v 2.3, if there is a error, the method will throw an java.io.IOException. This is new to v2.3! In earlier versions, it just returned false, but in retrospect that's a pretty poor way to handle it.

      Parameters:
        `filename` - Filename for reading binary data
      Returns:
        base64-encoded string
      Throws:
        `IOException` - if there is an error
      Since:
        2.1

    - #### encodeFileToFile

          public static void encodeFileToFile(String infile,
                                              String outfile)
                                       throws IOException

      Reads `infile` and encodes it to `outfile`.
      Parameters:
        `infile` - Input file
        `outfile` - Output file
      Throws:
        `IOException` - if there is an error
      Since:
        2.2

    - #### decodeFileToFile

          public static void decodeFileToFile(String infile,
                                              String outfile)
                                       throws IOException

      Reads `infile` and decodes it to `outfile`.
      Parameters:
        `infile` - Input file
        `outfile` - Output file
      Throws:
        `IOException` - if there is an error
      Since:
        2.2

Copyright © 2016 JBoss by Red Hat. All rights reserved.